# -*- encoding: utf-8 -*-
##############################################################################
# Copyright (c) 2011 OpenERP Venezuela (http://openerp.com.ve)
# All Rights Reserved.
# Programmed by: Israel Fermín Montilla  <israel@openerp.com.ve>
#                Miguel Delgado          <miguel@openerp.com.ve>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
from osv import osv
from osv import fields
from tools.translate import _
import base64
import netsvc

class print_sale_order_report(osv.osv_memory):
    """
    OpenERP Wizard : print.sale.order.report
    """
    _name = "print.sale.order.report"

    def __get_company_object(self, cr, uid):
        user = self.pool.get('res.users').browse(cr, uid, uid)
        print user
        if not user.company_id:
            raise except_osv(_('ERROR !'), _('There is no company configured for this user'))
        return user.company_id

    def _get_company(self, cr, uid, context=None):
        return self.__get_company_object(cr, uid).partner_id.name

    def _get_report(self, cr, uid, context=None):
        report = self.__get_company_object(cr, uid).sale_report_id
        if not report:
            rep_id = self.pool.get("ir.actions.report.xml").search(cr, uid, [('model', '=', 'sale.order'),], order="id")[0]
            report = self.pool.get("ir.actions.report.xml").browse(cr, uid, rep_id)

        service = netsvc.LocalService('report.' + report.report_name)
        (result, format) = service.create(cr, uid, context['active_ids'], {'model': context['active_model']}, {})
        return base64.encodestring(result)

    def _get_report_name(self, cr, uid, context):
        report = self.__get_company_object(cr, uid).sale_report_id
        if not report:
            rep_id = self.pool.get("ir.actions.report.xml").search(cr, uid, [('model', '=', 'sale.order'),], order="id")[0]
            report = self.pool.get("ir.actions.report.xml").browse(cr, uid, rep_id)
        return report.report_name

    def print_invoice(self, cr, uid, ids, context=None):
        return {'type': 'ir.actions.report.xml', 'report_name': self._get_report_name(cr, uid, context), 'datas': {'ids': context['active_ids']} }

    _columns = {
        'company': fields.char('Company', 64, readonly=True, requied=True),
        'report_format': fields.binary("Report", readonly=True, required=True),
        'wa':fields.boolean('With Attachment?'),
    }

    _defaults = {
        'company': _get_company,
        'report_format': _get_report,
    }
print_sale_order_report()
